#include <sys/types.h>
#include <stdint.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>

int main (int argc, char*argv[])
{
  pid_t pid; /* Declare a pid type. */
  pid_t mypid; /* Declare a second pid type */
  char cmd[255];
  char prev[255];
  char sb[2];
  int keepGoing = 1;
  
  mypid = getpid(); /* Get my pid from the OS. */
  printf("The shell, wws shell, is executing.  My PID is: %d. (%x)\n", mypid, mypid);   /* Print out my process ID data. */
  
  while ((keepGoing != 0))
  {
    printf("\nWWS->");
	
	memset (&cmd[0], 0, sizeof(cmd) );
	fgets(cmd, sizeof(cmd), stdin);
 
        if (strncmp(&cmd[0], "p", 1)==0)
        {
          strcpy(&cmd[0], &prev[0]);
	}  
        else if (strncmp(&cmd[0], "rm", 2)==0)
        {
          printf("Are you really sure you want to do this: %s\n", cmd);
          fgets(sb, 2, stdin);

          if (strncmp(&sb[0], "Y", 1)==0)
          {
            // DOIT
          }
          else
          {
            strcpy(cmd, "echo Not deleting it.");
          }
        }


	// Determine what to do.  If the command is exit, exit the shell.
	if (strncmp(&cmd[0], "exit", 4)==0)
	{
	  // Exit the shell.
	  keepGoing = 0;
	  printf("Exiting");
	}
	else
	{
	  strcpy(&prev[0], &cmd[0]);
	  // Fork a new process.
	  pid = fork();   /* Fork a child process of this process. */
	  
	  if (pid < 0) 
	  { /* An error occurred. */ }
      else if (pid > 0) 
		{ /* I am the parent process and my child is the following process. */
        printf("Start %s as pid is %x. \n", cmd, pid);
		
		// Determine if the command should execute in the background.
		if (cmd[0]=='&')
		{
			// Execute the program in the background.
		}
		else
		{
			// Wait for the command to finish.
			wait(pid);
		}
	  }
      else 
	  { /* I am the child process. */
		if (cmd[0]=='&')
		{
		  system(&cmd[1]);
		}
		else
		{
		  system(&cmd[0]);
		}
		exit(0);
	  }
 	}
  }
  exit(0);  /* Exit the program, returning 0 as an error code.*/
}
